"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var functionAppService_1 = require("../../services/functionAppService");
var resourceService_1 = require("../../services/resourceService");
var utils_1 = require("../../shared/utils");
var azureBasePlugin_1 = require("../azureBasePlugin");
var AzureDeployPlugin = /** @class */ (function (_super) {
    __extends(AzureDeployPlugin, _super);
    function AzureDeployPlugin(serverless, options) {
        var _this = _super.call(this, serverless, options) || this;
        _this.hooks = {
            "deploy:deploy": _this.deploy.bind(_this),
            "deploy:list:list": _this.list.bind(_this),
        };
        _this.commands = {
            deploy: {
                commands: {
                    list: {
                        usage: "List deployments",
                        lifecycleEvents: [
                            "list"
                        ]
                    }
                },
                options: {
                    resourceGroup: {
                        usage: "Resource group for the service",
                        shortcut: "g",
                    },
                    subscriptionId: {
                        usage: "Sets the Azure subscription ID",
                        shortcut: "i",
                    },
                    package: {
                        usage: "Package to deploy",
                        shortcut: "p",
                    }
                }
            }
        };
        return _this;
    }
    AzureDeployPlugin.prototype.list = function () {
        return __awaiter(this, void 0, void 0, function () {
            var resourceService, deployments, stringDeployments, deployments_1, deployments_1_1, dep, timestampFromName, dateTime;
            var e_1, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.log("Listing deployments");
                        resourceService = new resourceService_1.ResourceService(this.serverless, this.options);
                        return [4 /*yield*/, resourceService.getDeployments()];
                    case 1:
                        deployments = _b.sent();
                        if (!deployments || deployments.length === 0) {
                            this.log("No deployments found for resource group '" + resourceService.getResourceGroupName() + "'");
                            return [2 /*return*/];
                        }
                        stringDeployments = "\n\nDeployments";
                        try {
                            for (deployments_1 = __values(deployments), deployments_1_1 = deployments_1.next(); !deployments_1_1.done; deployments_1_1 = deployments_1.next()) {
                                dep = deployments_1_1.value;
                                stringDeployments += "\n-----------\n";
                                stringDeployments += "Name: " + dep.name + "\n";
                                timestampFromName = utils_1.Utils.getTimestampFromName(dep.name);
                                stringDeployments += "Timestamp: " + ((timestampFromName) ? timestampFromName : "None") + "\n";
                                dateTime = timestampFromName ? new Date(+timestampFromName).toISOString() : "None";
                                stringDeployments += "Datetime: " + dateTime + "\n";
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (deployments_1_1 && !deployments_1_1.done && (_a = deployments_1.return)) _a.call(deployments_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        stringDeployments += "-----------\n";
                        this.log(stringDeployments);
                        return [2 /*return*/];
                }
            });
        });
    };
    AzureDeployPlugin.prototype.deploy = function () {
        return __awaiter(this, void 0, void 0, function () {
            var resourceService, functionAppService, zipFile, functionApp;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        resourceService = new resourceService_1.ResourceService(this.serverless, this.options);
                        functionAppService = new functionAppService_1.FunctionAppService(this.serverless, this.options);
                        zipFile = functionAppService.getFunctionZipFile();
                        if (!fs_1.default.existsSync(zipFile)) {
                            this.log("Function app zip file '" + zipFile + "' does not exist");
                            return [2 /*return*/, Promise.resolve()];
                        }
                        return [4 /*yield*/, resourceService.deployResourceGroup()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, functionAppService.deploy()];
                    case 2:
                        functionApp = _a.sent();
                        return [4 /*yield*/, functionAppService.uploadFunctions(functionApp)];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return AzureDeployPlugin;
}(azureBasePlugin_1.AzureBasePlugin));
exports.AzureDeployPlugin = AzureDeployPlugin;
