"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = __importDefault(require("lodash"));
var mockFactory_1 = require("../test/mockFactory");
var apimService_1 = require("./apimService");
var utils_1 = require("../test/utils");
var axios_1 = __importDefault(require("axios"));
var arm_apimanagement_1 = require("@azure/arm-apimanagement");
var apim_get_service_404_json_1 = __importDefault(require("../test/responses/apim-get-service-404.json"));
var apim_get_service_200_json_1 = __importDefault(require("../test/responses/apim-get-service-200.json"));
var apim_get_api_200_json_1 = __importDefault(require("../test/responses/apim-get-api-200.json"));
var apim_get_api_404_json_1 = __importDefault(require("../test/responses/apim-get-api-404.json"));
var functionAppService_1 = require("./functionAppService");
var utils_2 = require("../shared/utils");
describe("APIM Service", function () {
    var apimConfig = mockFactory_1.MockFactory.createTestApimConfig();
    var serverless;
    beforeEach(function () {
        var slsConfig = __assign({}, mockFactory_1.MockFactory.createTestService(mockFactory_1.MockFactory.createTestSlsFunctionConfig()), { service: "test-sls", provider: {
                name: "azure",
                resourceGroup: "test-sls-rg",
                region: "West US",
                apim: apimConfig,
            } });
        serverless = mockFactory_1.MockFactory.createTestServerless({
            service: slsConfig
        });
        serverless.variables = __assign({}, serverless.variables, { azureCredentials: mockFactory_1.MockFactory.createTestAzureCredentials(), subscriptionId: "ABC123" });
    });
    it("is defined", function () {
        expect(apimService_1.ApimService).toBeDefined();
    });
    it("can be instantiated", function () {
        var service = new apimService_1.ApimService(serverless);
        expect(service).not.toBeNull();
    });
    it("when generated, has a shorted region name in the resource name", function () {
        // if APIM name is ommited, it should auto-generate one that contains a shortened region name
        var apimConfigName = mockFactory_1.MockFactory.createTestApimConfig(true);
        serverless.service.provider.apim = apimConfigName;
        var service = new apimService_1.ApimService(serverless);
        var expectedRegionName = utils_2.Utils.createShortAzureRegionName(service.getRegion());
        expect(apimConfigName.name.includes(expectedRegionName)).toBeTruthy();
    });
    describe("Get service reference", function () {
        it("returns null when service doesn't exist", function () { return __awaiter(_this, void 0, void 0, function () {
            var service, resource;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        axios_1.default.request = jest.fn(function (requestConfig) { return mockFactory_1.MockFactory.createTestAxiosResponse(requestConfig, apim_get_service_404_json_1.default, 404); });
                        service = new apimService_1.ApimService(serverless);
                        return [4 /*yield*/, service.get()];
                    case 1:
                        resource = _a.sent();
                        expect(resource).toBeNull();
                        return [2 /*return*/];
                }
            });
        }); });
        it("returns null when APIM is not configured", function () { return __awaiter(_this, void 0, void 0, function () {
            var service, resource;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        serverless.service.provider["apim"] = null;
                        service = new apimService_1.ApimService(serverless);
                        return [4 /*yield*/, service.get()];
                    case 1:
                        resource = _a.sent();
                        expect(resource).toBeNull();
                        return [2 /*return*/];
                }
            });
        }); });
        it("returns instance of service resource", function () { return __awaiter(_this, void 0, void 0, function () {
            var expectedResponse, service, resource;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        expectedResponse = utils_1.interpolateJson(apim_get_service_200_json_1.default, {
                            resourceGroup: {
                                name: serverless.service.provider["resourceGroup"],
                                location: serverless.service.provider.region,
                            },
                            resource: {
                                name: apimConfig.name,
                            },
                        });
                        axios_1.default.request = jest.fn(function (requestConfig) { return mockFactory_1.MockFactory.createTestAxiosResponse(requestConfig, expectedResponse); });
                        service = new apimService_1.ApimService(serverless);
                        return [4 /*yield*/, service.get()];
                    case 1:
                        resource = _a.sent();
                        expect(resource).not.toBeNull();
                        expect(resource).toMatchObject({
                            name: apimConfig.name,
                            location: serverless.service.provider.region,
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe("Get API reference", function () {
        it("returns null when API doesn't exist", function () { return __awaiter(_this, void 0, void 0, function () {
            var service, api;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        axios_1.default.request = jest.fn(function (requestConfig) { return mockFactory_1.MockFactory.createTestAxiosResponse(requestConfig, apim_get_api_404_json_1.default, 404); });
                        service = new apimService_1.ApimService(serverless);
                        return [4 /*yield*/, service.getApi()];
                    case 1:
                        api = _a.sent();
                        expect(api).toBeNull();
                        return [2 /*return*/];
                }
            });
        }); });
        it("returns null when APIM config does not exist", function () { return __awaiter(_this, void 0, void 0, function () {
            var service, api;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        serverless.service.provider["apim"] = null;
                        service = new apimService_1.ApimService(serverless);
                        return [4 /*yield*/, service.getApi()];
                    case 1:
                        api = _a.sent();
                        expect(api).toBeNull();
                        return [2 /*return*/];
                }
            });
        }); });
        it("returns the API reference", function () { return __awaiter(_this, void 0, void 0, function () {
            var expectedResponse, service, api;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        expectedResponse = utils_1.interpolateJson(apim_get_api_200_json_1.default, {
                            resourceGroup: {
                                name: serverless.service.provider["resourceGroup"],
                                location: serverless.service.provider.region,
                            },
                            service: {
                                name: apimConfig.name,
                            },
                            resource: {
                                name: apimConfig.api.name,
                                displayName: apimConfig.api.displayName,
                                description: apimConfig.api.description,
                                path: apimConfig.api.path,
                            },
                        });
                        axios_1.default.request = jest.fn(function (requestConfig) { return mockFactory_1.MockFactory.createTestAxiosResponse(requestConfig, expectedResponse); });
                        service = new apimService_1.ApimService(serverless);
                        return [4 /*yield*/, service.getApi()];
                    case 1:
                        api = _a.sent();
                        expect(api).not.toBeNull();
                        expect(api).toMatchObject({
                            displayName: apimConfig.api.displayName,
                            description: apimConfig.api.description,
                            path: apimConfig.api.path,
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe("Deploying API", function () {
        var backendConfig;
        var resourceGroupName;
        var appName;
        var serviceName;
        var apiName;
        var backendName;
        var functionApp;
        var masterKey;
        var expectedApi;
        var expectedApiResult;
        var expectedBackend;
        var expectedProperty;
        beforeEach(function () {
            backendConfig = apimConfig.backend || {};
            resourceGroupName = serverless.service.provider["resourceGroup"];
            appName = serverless.service["service"];
            serviceName = apimConfig.name;
            apiName = apimConfig.api.name;
            backendName = backendConfig.name || appName;
            functionApp = {
                id: "/testapp1",
                name: "Test Site",
                location: "West US",
                defaultHostName: "testsite.azurewebsites.net",
            };
            masterKey = "ABC123";
            functionAppService_1.FunctionAppService.prototype.get = jest.fn(function () { return Promise.resolve(functionApp); });
            functionAppService_1.FunctionAppService.prototype.getMasterKey = jest.fn(function () { return Promise.resolve(masterKey); });
            expectedApi = {
                isCurrent: true,
                subscriptionRequired: apimConfig.api.subscriptionRequired,
                displayName: apimConfig.api.displayName,
                description: apimConfig.api.description,
                path: apimConfig.api.path,
                protocols: apimConfig.api.protocols,
            };
            expectedApiResult = {
                id: apimConfig.api.name,
                name: apimConfig.api.name,
                isCurrent: true,
                subscriptionRequired: apimConfig.api.subscriptionRequired,
                displayName: apimConfig.api.displayName,
                description: apimConfig.api.description,
                path: apimConfig.api.path,
                protocols: apimConfig.api.protocols,
            };
            expectedBackend = {
                credentials: {
                    header: {
                        "x-functions-key": ["{{" + serverless.service["service"] + "-key}}"],
                    },
                },
                title: backendConfig.title || functionApp.name,
                tls: backendConfig.tls,
                proxy: backendConfig.proxy,
                description: backendConfig.description,
                protocol: backendConfig.protocol || "http",
                resourceId: "https://management.azure.com" + functionApp.id,
                url: "https://" + functionApp.defaultHostName + "/api",
            };
            expectedProperty = {
                displayName: serverless.service["service"] + "-key",
                secret: true,
                value: masterKey,
            };
        });
        it("ensures API, backend and keys have all been set", function () { return __awaiter(_this, void 0, void 0, function () {
            var apimService, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        arm_apimanagement_1.Api.prototype.createOrUpdate =
                            jest.fn(function () { return mockFactory_1.MockFactory.createTestArmSdkResponse(expectedApiResult, 201); });
                        arm_apimanagement_1.Backend.prototype.createOrUpdate =
                            jest.fn(function () { return mockFactory_1.MockFactory.createTestArmSdkResponse(expectedBackend, 201); });
                        arm_apimanagement_1.Property.prototype.createOrUpdate =
                            jest.fn(function () { return mockFactory_1.MockFactory.createTestArmSdkResponse(expectedProperty, 201); });
                        arm_apimanagement_1.ApiPolicy.prototype.createOrUpdate = jest.fn(function () { return Promise.resolve(null); });
                        apimService = new apimService_1.ApimService(serverless);
                        return [4 /*yield*/, apimService.deployApi()];
                    case 1:
                        result = _a.sent();
                        expect(result).toMatchObject(expectedApiResult);
                        expect(arm_apimanagement_1.Api.prototype.createOrUpdate).toBeCalledWith(resourceGroupName, serviceName, apiName, expectedApi);
                        // No CORS policy by default
                        expect(arm_apimanagement_1.ApiPolicy.prototype.createOrUpdate).not.toBeCalled();
                        expect(arm_apimanagement_1.Backend.prototype.createOrUpdate).toBeCalledWith(resourceGroupName, serviceName, backendName, expectedBackend);
                        expect(arm_apimanagement_1.Property.prototype.createOrUpdate).toBeCalledWith(resourceGroupName, serviceName, expectedProperty.displayName, expectedProperty);
                        return [2 /*return*/];
                }
            });
        }); });
        it("deploys API CORS policy when defined within configuration", function () { return __awaiter(_this, void 0, void 0, function () {
            var corsPolicy, apimService, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        arm_apimanagement_1.Api.prototype.createOrUpdate =
                            jest.fn(function () { return mockFactory_1.MockFactory.createTestArmSdkResponse(expectedApiResult, 201); });
                        arm_apimanagement_1.Backend.prototype.createOrUpdate =
                            jest.fn(function () { return mockFactory_1.MockFactory.createTestArmSdkResponse(expectedBackend, 201); });
                        arm_apimanagement_1.Property.prototype.createOrUpdate =
                            jest.fn(function () { return mockFactory_1.MockFactory.createTestArmSdkResponse(expectedProperty, 201); });
                        arm_apimanagement_1.ApiPolicy.prototype.createOrUpdate =
                            jest.fn(function () { return mockFactory_1.MockFactory.createTestArmSdkResponse(expectedProperty, 201); });
                        corsPolicy = mockFactory_1.MockFactory.createTestMockApiCorsPolicy();
                        serverless.service.provider["apim"]["cors"] = corsPolicy;
                        apimService = new apimService_1.ApimService(serverless);
                        return [4 /*yield*/, apimService.deployApi()];
                    case 1:
                        result = _a.sent();
                        expect(result).not.toBeNull();
                        expect(arm_apimanagement_1.ApiPolicy.prototype.createOrUpdate).toBeCalledWith(resourceGroupName, serviceName, apiName, {
                            format: "rawxml",
                            value: expect.stringContaining("cors"),
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it("returns null when APIM is not configured", function () { return __awaiter(_this, void 0, void 0, function () {
            var service, api;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        serverless.service.provider["apim"] = null;
                        service = new apimService_1.ApimService(serverless);
                        return [4 /*yield*/, service.deployApi()];
                    case 1:
                        api = _a.sent();
                        expect(api).toBeNull();
                        return [2 /*return*/];
                }
            });
        }); });
        it("fails when API deployment fails", function () { return __awaiter(_this, void 0, void 0, function () {
            var apiError, apimService;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        apiError = "Error creating API";
                        arm_apimanagement_1.Api.prototype.createOrUpdate = jest.fn(function () { return Promise.reject(apiError); });
                        apimService = new apimService_1.ApimService(serverless);
                        return [4 /*yield*/, expect(apimService.deployApi()).rejects.toEqual(apiError)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it("fails when Backend deployment fails", function () { return __awaiter(_this, void 0, void 0, function () {
            var apiError, apimService;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        apiError = "Error creating Backend";
                        arm_apimanagement_1.Api.prototype.createOrUpdate =
                            jest.fn(function () { return mockFactory_1.MockFactory.createTestArmSdkResponse(expectedApiResult, 201); });
                        arm_apimanagement_1.Backend.prototype.createOrUpdate = jest.fn(function () { return Promise.reject(apiError); });
                        apimService = new apimService_1.ApimService(serverless);
                        return [4 /*yield*/, expect(apimService.deployApi()).rejects.toEqual(apiError)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it("fails when Property deployment fails", function () { return __awaiter(_this, void 0, void 0, function () {
            var apiError, apimService;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        apiError = "Error creating Property";
                        arm_apimanagement_1.Api.prototype.createOrUpdate =
                            jest.fn(function () { return mockFactory_1.MockFactory.createTestArmSdkResponse(expectedApiResult, 201); });
                        arm_apimanagement_1.Backend.prototype.createOrUpdate =
                            jest.fn(function () { return mockFactory_1.MockFactory.createTestArmSdkResponse(expectedBackend, 201); });
                        arm_apimanagement_1.Property.prototype.createOrUpdate = jest.fn(function () { return Promise.reject(apiError); });
                        apimService = new apimService_1.ApimService(serverless);
                        return [4 /*yield*/, expect(apimService.deployApi()).rejects.toEqual(apiError)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe("Deploying Functions", function () {
        it("performs a noop when APIM config has not been configured", function () { return __awaiter(_this, void 0, void 0, function () {
            var apimService, deploySpy, serviceResource, api;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        serverless.service.provider["apim"] = null;
                        apimService = new apimService_1.ApimService(serverless);
                        deploySpy = jest.spyOn(apimService, "deployFunction");
                        serviceResource = mockFactory_1.MockFactory.createTestApimService();
                        api = mockFactory_1.MockFactory.createTestApimApi();
                        return [4 /*yield*/, apimService.deployFunctions(serviceResource, api)];
                    case 1:
                        _a.sent();
                        expect(deploySpy).not.toBeCalled();
                        return [2 /*return*/];
                }
            });
        }); });
        it("ensures all serverless functions have been deployed into specified API", function () { return __awaiter(_this, void 0, void 0, function () {
            var slsFunctions, apimResource, apiContract, deployFunctionSpy, service, apimInstance, api, createOperationCall;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        slsFunctions = lodash_1.default.values(serverless.service["functions"]);
                        apimResource = {
                            name: apimConfig.name,
                            location: "West US",
                            publisherEmail: "someone@example.com",
                            publisherName: "Someone",
                            sku: {
                                capacity: 1,
                                name: "Consumption",
                            },
                        };
                        apiContract = apimConfig.api;
                        arm_apimanagement_1.ApiManagementService.prototype.get = jest.fn(function () { return mockFactory_1.MockFactory.createTestArmSdkResponse(apimResource, 200); });
                        arm_apimanagement_1.Api.prototype.get = jest.fn(function () { return mockFactory_1.MockFactory.createTestArmSdkResponse(apiContract, 200); });
                        arm_apimanagement_1.ApiOperation.prototype.createOrUpdate =
                            jest.fn(function (resourceGroup, serviceName, apiName, operationName, operationContract) {
                                var response = mockFactory_1.MockFactory.createTestArmSdkResponse(operationContract, 201);
                                return Promise.resolve(response);
                            });
                        arm_apimanagement_1.ApiOperationPolicy.prototype.createOrUpdate = jest.fn(function () { return Promise.resolve(null); });
                        deployFunctionSpy = jest.spyOn(apimService_1.ApimService.prototype, "deployFunction");
                        service = new apimService_1.ApimService(serverless);
                        return [4 /*yield*/, service.get()];
                    case 1:
                        apimInstance = _a.sent();
                        return [4 /*yield*/, service.getApi()];
                    case 2:
                        api = _a.sent();
                        return [4 /*yield*/, service.deployFunctions(apimInstance, api)];
                    case 3:
                        _a.sent();
                        expect(deployFunctionSpy).toBeCalledTimes(slsFunctions.length);
                        createOperationCall = arm_apimanagement_1.ApiOperation.prototype.createOrUpdate;
                        createOperationCall.mock.calls.forEach(function (args, index) {
                            var expected = slsFunctions[index].apim.operations[0];
                            var actual = args[4];
                            expect(actual).toMatchObject({
                                displayName: expected.displayName,
                                description: expected.description || "",
                                method: expected.method,
                                urlTemplate: expected.urlTemplate,
                                templateParameters: expected.templateParameters || [],
                                responses: expected.responses || [],
                            });
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
