import { BaseService } from "./baseService";
import Serverless from "serverless";
import { FunctionAppService } from "./functionAppService";
export declare class InvokeService extends BaseService {
    functionAppService: FunctionAppService;
    constructor(serverless: Serverless, options: Serverless.Options);
    /**
     * Invoke an Azure Function
     * @param method HTTP method
     * @param functionName Name of function to invoke
     * @param data Data to use as body or query params
     */
    invoke(method: string, functionName: string, data?: any): Promise<import("axios").AxiosResponse<any>>;
    private getQueryString;
    /**
   * Get options object
   * @param method The method used (POST or GET)
   * @param data Data to use as body or query params
   */
    private getOptions;
}
