"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var mock_fs_1 = __importDefault(require("mock-fs"));
var path_1 = __importDefault(require("path"));
var mockFactory_1 = require("../test/mockFactory");
var rollbackService_1 = require("./rollbackService");
jest.mock("./azureBlobStorageService");
var azureBlobStorageService_1 = require("./azureBlobStorageService");
jest.mock("./resourceService");
var resourceService_1 = require("./resourceService");
jest.mock("./functionAppService");
var functionAppService_1 = require("./functionAppService");
jest.mock("./armService");
var armService_1 = require("./armService");
describe("Rollback Service", function () {
    var e_1, _a;
    var template = mockFactory_1.MockFactory.createTestArmTemplate();
    var parameters = mockFactory_1.MockFactory.createTestParameters();
    try {
        for (var _b = __values(Object.keys(parameters)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var p = _c.value;
            parameters[p] = parameters[p].value;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    var appStub = "appStub";
    var sasURL = "sasURL";
    var containerName = "deployment-artifacts";
    var artifactName = mockFactory_1.MockFactory.createTestDeployment().name.replace("deployment", "artifact") + ".zip";
    var artifactPath = ".serverless" + path_1.default.sep + artifactName;
    var armDeployment = { template: template, parameters: parameters };
    function createOptions(timestamp) {
        return __assign({}, mockFactory_1.MockFactory.createTestServerlessOptions(), { timestamp: timestamp || mockFactory_1.MockFactory.createTestTimestamp() });
    }
    function createService(sls, options) {
        return new rollbackService_1.RollbackService(sls || mockFactory_1.MockFactory.createTestServerless(), options || createOptions());
    }
    beforeEach(function () {
        // Mocking the file system so that files are not created in project directory
        mock_fs_1.default({});
        resourceService_1.ResourceService.prototype.getDeployments = jest.fn(function () { return Promise.resolve(__spread(mockFactory_1.MockFactory.createTestDeployments(5, true), [
            mockFactory_1.MockFactory.createTestDeployment("noTimestamp")
        ])); });
        resourceService_1.ResourceService.prototype.getDeploymentTemplate = jest.fn(function () { return Promise.resolve({ template: template }); });
        azureBlobStorageService_1.AzureBlobStorageService.prototype.generateBlobSasTokenUrl = jest.fn(function () { return sasURL; });
        functionAppService_1.FunctionAppService.prototype.get = jest.fn(function () { return appStub; });
    });
    afterEach(function () {
        mock_fs_1.default.restore();
        jest.resetAllMocks();
    });
    it("should return early with no timestamp", function () { return __awaiter(_this, void 0, void 0, function () {
        var sls, options, service, calls;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sls = mockFactory_1.MockFactory.createTestServerless();
                    options = {};
                    service = createService(sls, options);
                    return [4 /*yield*/, service.rollback()];
                case 1:
                    _a.sent();
                    calls = sls.cli.log.mock.calls;
                    expect(calls[0][0]).toEqual("Need to specify a timestamp for rollback. Run `sls deploy list` to see timestamps of deployments");
                    return [2 /*return*/];
            }
        });
    }); });
    it("should return early with invalid timestamp", function () { return __awaiter(_this, void 0, void 0, function () {
        var sls, timestamp, options, service, calls;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sls = mockFactory_1.MockFactory.createTestServerless();
                    timestamp = "garbage";
                    options = createOptions(timestamp);
                    service = createService(sls, options);
                    return [4 /*yield*/, service.rollback()];
                case 1:
                    _a.sent();
                    calls = sls.cli.log.mock.calls;
                    expect(calls[0][0]).toEqual("Couldn't find deployment with timestamp: " + timestamp);
                    return [2 /*return*/];
            }
        });
    }); });
    it("should deploy blob package directly to function app", function () { return __awaiter(_this, void 0, void 0, function () {
        var service;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    service = createService();
                    return [4 /*yield*/, service.rollback()];
                case 1:
                    _a.sent();
                    expect(azureBlobStorageService_1.AzureBlobStorageService.prototype.initialize).toBeCalled();
                    expect(armService_1.ArmService.prototype.deployTemplate).toBeCalledWith(armDeployment);
                    expect(azureBlobStorageService_1.AzureBlobStorageService.prototype.downloadBinary).toBeCalledWith(containerName, artifactName, artifactPath);
                    expect(functionAppService_1.FunctionAppService.prototype.get).toBeCalled();
                    expect(functionAppService_1.FunctionAppService.prototype.uploadZippedArfifactToFunctionApp).toBeCalledWith(appStub, artifactPath);
                    return [2 /*return*/];
            }
        });
    }); });
    it("should deploy function app with SAS URL", function () { return __awaiter(_this, void 0, void 0, function () {
        var sls, deploymentConfig, service;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sls = mockFactory_1.MockFactory.createTestServerless();
                    deploymentConfig = {
                        runFromBlobUrl: true
                    };
                    sls["deploy"] = deploymentConfig;
                    service = createService(sls);
                    return [4 /*yield*/, service.rollback()];
                case 1:
                    _a.sent();
                    expect(azureBlobStorageService_1.AzureBlobStorageService.prototype.initialize).toBeCalled();
                    expect(armService_1.ArmService.prototype.deployTemplate).toBeCalledWith(__assign({}, armDeployment, { parameters: __assign({}, armDeployment.parameters, { functionAppRunFromPackage: sasURL }) }));
                    expect(azureBlobStorageService_1.AzureBlobStorageService.prototype.downloadBinary).not.toBeCalled();
                    expect(azureBlobStorageService_1.AzureBlobStorageService.prototype.generateBlobSasTokenUrl).toBeCalledWith(containerName, artifactName);
                    expect(functionAppService_1.FunctionAppService.prototype.get).not.toBeCalled();
                    expect(functionAppService_1.FunctionAppService.prototype.uploadZippedArfifactToFunctionApp).not.toBeCalled();
                    return [2 /*return*/];
            }
        });
    }); });
});
